From c893fe67fc56b9f81c286e8028037eed41522fe8 Mon Sep 17 00:00:00 2001
From: Jack Magne <jmagne@dhcp-16-206.sjc.redhat.com>
Date: Wed, 1 Jun 2016 10:23:33 -0700
Subject: [PATCH] First cut of scp03 support. Supports the g&d smartcafe out of
 the box.

Developer keyset token operations and key change over supported.

Caveats.

-The diversification step going from master key to card key uses DES3 as required for the token.
-After that point, everything is scp03 to the spec with minor excpetions so far.

Supports 128 bit AES for now. Will resolve this.

Minor config tweaks:

TPS

Symmetric Key Changeover

Use this applet for scp03:

RSA/KeyRecovery/GP211/SCP02/SCP03 applet : 1.5.558cdcff.ijc

TKS:

Symmetric Key Changeover

tks.mk_mappings.#02#03=internal:new_master

tks.defKeySet.mk_mappings.#02#03=internal:new_master

Use the uncommented one because scp03 returns a different key set data string.

ToDo:

-Support the rest of the AES sizes other than 128.
-Support optional RMAC apdu.
-Test and adjust the config capability for other tokens.
-Support AES master key. Right now the standard key ends up creating AES card and session keys.
---
 .../src/org/dogtagpki/tps/TPSConnection.java       |   8 +-
 base/common/src/org/dogtagpki/tps/apdu/APDU.java   |  68 ++
 base/common/src/org/dogtagpki/tps/main/Util.java   | 570 ++++++++++++++-
 .../src/org/dogtagpki/tps/msg/TPSMessage.java      |   6 +
 .../src/com/netscape/cms/servlet/tks/GPParams.java | 108 +++
 .../cms/src/com/netscape/cms/servlet/tks/KDF.java  |  59 +-
 .../netscape/cms/servlet/tks/NistSP800_108KDF.java | 426 ++++++++++-
 .../cms/servlet/tks/SecureChannelProtocol.java     | 779 ++++++++++++++++++--
 .../com/netscape/cms/servlet/tks/StandardKDF.java  |  41 +-
 .../com/netscape/cms/servlet/tks/TokenServlet.java | 800 ++++++++++++++++++++-
 .../dogtagpki/server/connector/IRemoteRequest.java |   2 +
 .../channel/PlatformAndSecChannelProtoInfo.java    |   8 +
 .../server/tps/channel/SecureChannel.java          | 207 +++++-
 .../tps/cms/TKSComputeSessionKeyResponse.java      |   8 +
 .../server/tps/cms/TKSRemoteRequestHandler.java    | 157 +++-
 .../org/dogtagpki/server/tps/engine/TPSEngine.java |  58 +-
 .../server/tps/processor/TPSEnrollProcessor.java   |  10 +-
 .../server/tps/processor/TPSProcessor.java         | 162 ++++-
 18 files changed, 3314 insertions(+), 163 deletions(-)
 create mode 100644 base/server/cms/src/com/netscape/cms/servlet/tks/GPParams.java

diff --git a/base/common/src/org/dogtagpki/tps/TPSConnection.java b/base/common/src/org/dogtagpki/tps/TPSConnection.java
index c5a971e..dd9538b 100644
--- a/base/common/src/org/dogtagpki/tps/TPSConnection.java
+++ b/base/common/src/org/dogtagpki/tps/TPSConnection.java
@@ -93,9 +93,11 @@ public class TPSConnection {
         String s = message.encode();
 
         // don't print the pdu_data
-        int idx = s.lastIndexOf("pdu_data=");
-        String toDebug = null; 
-        if (idx == -1)
+        int idx =  s.lastIndexOf("pdu_data=");
+
+        int debug = 0;
+        String toDebug = null;
+        if (idx == -1 || debug == 1)
             CMS.debug("TPSConnection.write: Writing: " + s);
         else {
             toDebug = s.substring(0, idx-1);
diff --git a/base/common/src/org/dogtagpki/tps/apdu/APDU.java b/base/common/src/org/dogtagpki/tps/apdu/APDU.java
index 009c470..545c842 100644
--- a/base/common/src/org/dogtagpki/tps/apdu/APDU.java
+++ b/base/common/src/org/dogtagpki/tps/apdu/APDU.java
@@ -219,6 +219,74 @@ public abstract class APDU {
         data.set(dataEncrypted);
     }
 
+    //Used for scp03, provide a padding buffer of the requested size, first byte set to 0x80
+    public void padBuffer80(TPSBuffer buffer, int blockSize) {
+        int length = buffer.size();
+
+        int padSize = 0;
+
+        if( buffer == null || blockSize <= 0)
+            return;
+
+        int rem = length % blockSize ;
+
+        padSize = blockSize - rem;
+
+        TPSBuffer padding = new TPSBuffer( padSize);
+        padding.setAt(0, (byte) 0x80);
+
+        buffer.add(padding);
+
+    }
+
+    //Assume the whole buffer is to be incremented
+    //Used for SCP03 encrypted apdu messages
+    public void incrementBuffer(TPSBuffer buffer) {
+
+        if(buffer == null)
+            return;
+
+        int len = buffer.size();
+
+        if (len < 1)
+            return;
+        int offset = 0;
+        for (short i = (short) (offset + len - 1); i >= offset; i--) {
+            byte cur = buffer.at(i);
+            if (cur != (byte) 0xFF) {
+                    cur++;
+                    buffer.setAt(i, cur);
+                    break;
+            } else
+                    buffer.setAt(i,(byte) 0x00);
+        }
+
+        System.out.println("enc buffer: " + buffer.toHexString());
+    }
+
+    //Implement SCP03 encrypted apdu scheme.
+    public void secureMessageSCP03(PK11SymKey encKey, TPSBuffer encryptionCounter) throws EBaseException {
+
+        TPSBuffer data = this.getData();
+
+        //increment encryption count and encrypt it for new iv
+
+        incrementBuffer(encryptionCounter);
+
+        if (data != null && data.size() > 0) {
+
+            padBuffer80(data, 16);
+
+            TPSBuffer encryptedCounter = Util.encryptDataAES(encryptionCounter, encKey, null);
+
+            TPSBuffer encryptedData = Util.encryptDataAES(data, encKey, encryptedCounter);
+
+            data.set(encryptedData);
+
+        }
+
+    }
+
     public void secureMessageSCP02(PK11SymKey encKey) throws EBaseException {
 
         if (encKey == null) {
diff --git a/base/common/src/org/dogtagpki/tps/msg/TPSMessage.java b/base/common/src/org/dogtagpki/tps/msg/TPSMessage.java
index c7ad7f7..aee4302 100644
--- a/base/common/src/org/dogtagpki/tps/msg/TPSMessage.java
+++ b/base/common/src/org/dogtagpki/tps/msg/TPSMessage.java
@@ -527,6 +527,12 @@ public class TPSMessage {
             }
         }
 
+        int debug = 1;
+
+        if (debug == 1) {
+            CMS.debug("TPSMessage.createMessage: message: " + message);
+        }
+
         TPSMessage new_msg = new TPSMessage(message);
 
         return new_msg.createMessage();
diff --git a/base/server/cms/src/com/netscape/cms/servlet/tks/GPParams.java b/base/server/cms/src/com/netscape/cms/servlet/tks/GPParams.java
new file mode 100644
index 0000000..f16481b
--- /dev/null
+++ b/base/server/cms/src/com/netscape/cms/servlet/tks/GPParams.java
@@ -0,0 +1,108 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package com.netscape.cms.servlet.tks;
+
+
+//Simple class used to hold scp03 related settings in TKS keyset config block
+// Ex: tks.defKeySet.prot3.divers=emv
+//     tks.defKeySet.prot3.diversVer1Keys=emv
+
+// Will probably be extended to allow params for future tokens
+
+public class GPParams {
+
+    public static String DIVER_EMV = "emv";
+    public static String DIVER_NONE = "none";
+    public static String DIVER_VISA2 = "visa2";
+    public static String NIST_SP800 = "nistsp_800";
+
+    public GPParams() {
+    }
+
+    // Diversification scheme for all keysets after 1
+    private String diversificationScheme;
+    //Diversification scheme for just version one or developer keys
+    private String version1DiversificationScheme;
+
+    public boolean isDiversEmv() {
+        if (DIVER_EMV.equalsIgnoreCase(diversificationScheme))
+            return true;
+        else
+            return false;
+    }
+
+    public boolean isDiversVisa2() {
+        if (DIVER_VISA2.equalsIgnoreCase(diversificationScheme))
+            return true;
+        else
+            return false;
+    }
+
+    public boolean isDiversNone() {
+        if (DIVER_NONE.equalsIgnoreCase(diversificationScheme))
+            return true;
+        else
+            return false;
+    }
+
+    public boolean isVer1DiversEmv() {
+        if (DIVER_EMV.equalsIgnoreCase(version1DiversificationScheme))
+            return true;
+        else
+            return false;
+    }
+
+    public boolean isVer1DiversVisa2() {
+        if (DIVER_VISA2.equalsIgnoreCase(version1DiversificationScheme))
+            return true;
+        else
+            return false;
+
+    }
+
+    public boolean isVer1DiversNone() {
+        if (DIVER_NONE.equalsIgnoreCase(version1DiversificationScheme))
+            return true;
+        else
+            return false;
+    }
+
+    public void setDiversificationScheme(String scheme) {
+        diversificationScheme = scheme;
+    }
+
+    public String getDiversificationScheme() {
+        return diversificationScheme;
+    }
+
+    public String getVersion1DiversificationScheme() {
+        return version1DiversificationScheme;
+    }
+
+    public void setVersion1DiversificationScheme(String version1DiversificationScheme) {
+        this.version1DiversificationScheme = version1DiversificationScheme;
+    }
+
+    public String toString() {
+        String output = " Version1 Diversification Scheme: " + version1DiversificationScheme + " All other versions : "
+                + diversificationScheme;
+
+        return output;
+    }
+
+}
diff --git a/base/server/cms/src/com/netscape/cms/servlet/tks/KDF.java b/base/server/cms/src/com/netscape/cms/servlet/tks/KDF.java
index 0407e29..e7b183b 100644
--- a/base/server/cms/src/com/netscape/cms/servlet/tks/KDF.java
+++ b/base/server/cms/src/com/netscape/cms/servlet/tks/KDF.java
@@ -41,9 +41,64 @@ public class KDF {
             /* Even...0xf0,0xf2,0xf4,0xf6,0xf8,0xfa,0xfc,0xfe */
             /* E */0xf1, 0xf2, 0xf4, 0xf7, 0xf8, 0xfb, 0xfd, 0xfe, };
 
-    public static byte[] getDiversificationData(byte[] context, String type) throws EBaseException {
+    //Add the emv diversification method, used in SCP03 g&d card.
+    public static byte[] getDiversificationData_EMV(byte[] context, String type) throws EBaseException {
 
-        String method = "KDF.getDiversificationData:";
+        String method = "KDF.getDiversificationData_EMV:";
+
+        CMS.debug(method + " entering ...");
+
+        if (context == null || type == null) {
+            throw new EBaseException(method + "Invalid input parameters!");
+        }
+
+        byte[] KDC = new byte[SecureChannelProtocol.DES2_LENGTH];
+
+        KDC[0] = context[4 + 0];
+        KDC[1] = context[4 + 1];
+        KDC[2] = context[4 + 2];
+        KDC[3] = context[4 + 3];
+        KDC[4] = context[4 + 4];
+        KDC[5] = context[4 + 5];
+        KDC[6] = (byte) 0xF0;
+
+        KDC[7] = 0x1;
+
+        KDC[8] = context[4 + 0];
+        KDC[9] = context[4 + 1];
+        KDC[10] = context[4 + 2];
+        KDC[11] = context[4 +3];
+        KDC[12] = context[4 + 4];
+        KDC[13] = context[4 + 5];
+        KDC[14] = (byte) 0x0f;
+
+        KDC[15] = 0x1;
+
+        if (type.equals(SecureChannelProtocol.encType))
+            return KDC;
+
+        KDC[7] = 0x02;
+        KDC[15] = 0x02;
+        if (type.equals(SecureChannelProtocol.macType))
+            return KDC;
+
+        KDC[7] = 0x03;
+        KDC[15] = 0x03;
+        if (type.equals(SecureChannelProtocol.kekType))
+            return KDC;
+
+        KDC[7] = 0x04;
+        KDC[15] = 0x04;
+        if (type.equals(SecureChannelProtocol.rmacType))
+            return KDC;
+        return KDC;
+
+    }
+
+    //Standard visa2 diversification method
+    public static byte[] getDiversificationData_VISA2(byte[] context, String type) throws EBaseException {
+
+        String method = "KDF.getDiversificationData_VISA2:";
 
         CMS.debug(method + " entering ...");
 
